#!/usr/bin/python2.4
# -*- coding: utf-8 -*-

import re
from cStringIO import StringIO

import pycurl

from moio.plugins.Sender import Sender
from moio.ConnectionManager import ConnectionManager
from moio.errors.SiteCustomError import SiteCustomError
from moio.errors.SiteConnectionError import SiteConnectionError
from moio.errors.SiteAuthError import SiteAuthError
from moio.errors.SenderError import SenderError

class Enel(Sender):
    """Permette di spedire SMS dal sito Enel.it"""
    
    maxLength = 110
    """Lunghezza massima del messaggio singolo inviabile da questo sito."""
    
    requiresRegistration = True
    """Questo plugin richiede nome utente e password?"""
    
    def isAvailable(self):
        """Ritorna true se questo plugin è utilizzabile."""
        return True
       
    def sendOne(self, number, text, username = None, password = None):
        """Spedisce un SMS con soli caratteri ASCII e di lunghezza massima maxLength
        con le credenziali specificate, supponendo Internet raggiungibile.
        """
        try:
            c = self.connectionManager.getCurl()
            c.setopt(pycurl.WRITEFUNCTION, self.doNothing)
            c.setopt(pycurl.POST, False)
            
            if number[:3] == "+39":
                number = number[3:]
            elif number[0]=="+":
                raise SiteCustomError(self.__class__.__name__,
                u"Questo sito permette di inviare SMS solo verso cellulari italiani.")
            
            #Visito la pagina iniziale
            c.setopt(pycurl.URL, "http://www.enel.it")
            c.perform()

            #Faccio il login
            saver = StringIO()
            c.setopt(pycurl.WRITEFUNCTION, saver.write)
            c.setopt(pycurl.POST, True)
            postFields = {}
            postFields["SpontaneousLogon"] = "/Index.asp"
            postFields["txtUsername"] = username
            postFields["txtPassword"] = password
            c.setopt(pycurl.POSTFIELDS,
                self.codingManager.urlEncode(postFields))
            c.setopt(pycurl.URL, "http://www.enel.it/AuthFiles/Login.aspx")
            c.perform()
            
            if (re.search("Autenticazione fallita", saver.getvalue()) != None):
                raise SiteAuthError(self.__class__.__name__)
                       
            #Visito la pagina degli SMS
            saver = StringIO()
            c.setopt(pycurl.WRITEFUNCTION, saver.write)
            c.setopt(pycurl.POST, False)
            c.setopt(pycurl.REFERER, "http://www.enel.it/Index.asp")
            c.setopt(pycurl.URL, "http://servizi.enel.it/sms/")
            c.perform()
            
            checkCode = ""
            try:
                savedPage = saver.getvalue()
                print savedPage
                checkCode = re.search('<input type="hidden" name="cksmsenel" value="([A-Z0-9]+)"',savedPage).group(1)
                print checkCode
            except AttributeError:
                raise SenderError(self.__class__.__name__)
            
            #Pre-invio
            saver = StringIO()
            c.setopt(pycurl.WRITEFUNCTION, saver.write)
            c.setopt(pycurl.POST, True)
            postFields = {}
            postFields["message"] = text
            postFields["prefix"] = number[0:3]
            postFields["gsm"] = number[3:]
            postFields["cksmsenel"] = checkCode
            c.setopt(pycurl.POSTFIELDS,
                self.codingManager.urlEncode(postFields))
    
            c.setopt(pycurl.URL,
                "http://servizi.enel.it/sms/service/scrivisms.asp?SMSstartpage=http://www.enel.it/Index.asp")
            c.perform()
            
            if (re.search("superato il limite massimo",
                saver.getvalue()) != None):
                raise SiteCustomError(self.__class__.__name__,
                    u"Sono esauriti gli SMS gratuiti di oggi.")
            
            checkCode = ""
            xFieldKey = ""
            xFieldValue = ""
            try:
                savedPage = saver.getvalue()
                print savedPage
                checkCode = re.search('<INPUT TYPE=hidden NAME=cksmsenel VALUE="([A-Z0-9]+)"',savedPage).group(1)
                print checkCode
                match = re.search('<INPUT TYPE=hidden NAME=x([0-9]+) VALUE=\'([0-9]+)\'>',savedPage)
                xFieldKey = match.group(1)
                xFieldValue = match.group(2)
            except AttributeError:
                raise SenderError(self.__class__.__name__)

            #Accetto il contratto
            saver = StringIO()
            c.setopt(pycurl.WRITEFUNCTION, saver.write)
            c.setopt(pycurl.POST, True)
            postFields = {}
            postFields["message"] = text
            postFields["prefix"] = number[0:3]
            postFields["gsm"] = number[3:]
            postFields["accetta"] = "yes"
            postFields["x"+str(xFieldKey)] = str(xFieldValue)
            postFields["cksmsenel"] = checkCode
            c.setopt(pycurl.POSTFIELDS,
                self.codingManager.urlEncode(postFields))
    
            c.setopt(pycurl.URL,
                "http://servizi.enel.it/sms/service/scrivisms.asp")
            c.perform()
                    
            if (re.search("superato il limite massimo",
                saver.getvalue()) != None):
                raise SiteCustomError(self.__class__.__name__,
                    u"Sono esauriti gli SMS gratuiti di oggi.")
            if (re.search("inviato correttamente", saver.getvalue()) is None):
                raise SenderError(self.__class__.__name__)

        except pycurl.error, e:
            errno, msg = e
            raise SiteConnectionError(self.__class__.__name__, self.codingManager.iso88591ToUnicode(msg))
