#!/usr/bin/python2.4
# -*- coding: utf-8 -*-

import re
import sys
from cStringIO import StringIO

import pycurl

from moio.plugins.Sender import Sender
from moio.ConnectionManager import ConnectionManager
from moio.errors.SiteCustomError import SiteCustomError
from moio.errors.SiteConnectionError import SiteConnectionError
from moio.errors.SiteAuthError import SiteAuthError
from moio.errors.SenderError import SenderError

from moio.plugins.captchadecoders.AskUserCaptchaDecoder import AskUserCaptchaDecoder

class Supercasella(Sender):
    """Permette di spedire SMS dal sito di aliceadsl.it, tramite Supercasella."""
    
    maxLength = 590
    """Lunghezza massima del messaggio singolo inviabile da questo sito."""

    requiresRegistration = True
    """Questo plugin richiede nome utente e password?"""
    
    def isAvailable(self):
        """Ritorna true se questo plugin è utilizzabile."""
        return AskUserCaptchaDecoder.getInstance().isAvailable()

    def sendOne(self, number, text, username = None, password = None):
        """Spedisce un SMS con soli caratteri ASCII e di lunghezza massima maxLength
        con le credenziali specificate, supponendo Internet raggiungibile.
        """
        try:
            c = self.connectionManager.getCurl()
            c.setopt(pycurl.WRITEFUNCTION, self.doNothing)
            c.setopt(pycurl.POST, False)
            
            #Faccio il login
            saver = StringIO()
            c.setopt(pycurl.WRITEFUNCTION, saver.write)
            c.setopt(pycurl.POST, True)
            postFields = {}
            postFields["URL_OK"] = "http://auth.rossoalice.alice.it/aap/serviceforwarder?sf_dest=ps"
            postFields["usr"] = username
            postFields["login"] = username + "@alice.it"
            postFields["password"] = password
            c.setopt(pycurl.POSTFIELDS,
            self.codingManager.urlEncode(postFields))
            c.setopt(pycurl.URL,
                "http://authsrs.alice.it/aap/validatecredential")
            c.perform()
            if ((re.search(u'non sono corretti', saver.getvalue()) is not None) or
               (re.search(u"utenza inserita al momento non ", saver.getvalue()) is not None)):
                raise SiteAuthError(self.__class__.__name__)
            
            #Visito il form degli SMS
            saver = StringIO()
            c.setopt(pycurl.WRITEFUNCTION, saver.write)
            c.setopt(pycurl.URL, "http://auth.rossoalice.alice.it/aap/serviceforwarder?sf_dest=ibox_inviosms")
            c.perform()
            saver = StringIO()
            c.setopt(pycurl.WRITEFUNCTION, saver.write)
            c.setopt(pycurl.URL, "http://webloginmobile.rossoalice.alice.it/ews/jsp/it_IT-TIM-SUNRISE/jsp/SMS/composerSMS.jsp?locale=it_IT-TIM-SUNRISE&ID_Field=0&ID_Value=0&id_clickto=0&dummy=dummy")
            c.perform()
            
            #Spedisco l'SMS
            postFields = {}
            postFields["msisdn"] = username
            postFields["locale"] = "it_IT-TIM-SUNRISE"
            postFields["SENDER"] = ""
            postFields["DEST"] = number
            postFields["ABGDEST"] = ""
            postFields["NOME_LISTA"] = " "
            postFields["OTPWD"] = " "
            postFields["TYPE"] = "smsf"
            postFields["SHORT_MESSAGE"] = text
            postFields["SHORT_MESSAGE_2"] = text
 
            saver = StringIO()
            c.setopt(pycurl.WRITEFUNCTION, saver.write)
            c.setopt(pycurl.URL, "http://webloginmobile.rossoalice.alice.it/ews/jsp/it_IT-TIM-SUNRISE/ews/sunrise/sendSMS.jsp")
            
            c.setopt(pycurl.POSTFIELDS,
                self.codingManager.urlEncode(postFields))
            c.perform()
          
            captchaBroken = False
            while captchaBroken == False:
                saver = StringIO()
                c.setopt(pycurl.WRITEFUNCTION, saver.write)
                c.setopt(pycurl.POST, False)
                c.setopt(pycurl.URL, "http://webloginmobile.rossoalice.alice.it/ews/EwsJCaptcha.jpg")
                c.perform()
#                print saver.getvalue()
                
                postFields = {}
                postFields["msisdn"] = username
                postFields["SENDER"] = username
                postFields["DEST"] = number
                postFields["SHORT_MESSAGE"] = text
                postFields["captchafield"]=AskUserCaptchaDecoder.getInstance().decodeCaptcha(saver, self.__class__.__name__)
                c.setopt(pycurl.POSTFIELDS,
                      self.codingManager.urlEncode(postFields))
                saver = StringIO()
                c.setopt(pycurl.WRITEFUNCTION, saver.write)
                c.setopt(pycurl.URL, "http://webloginmobile.rossoalice.alice.it/ews/jsp/it_IT-TIM-SUNRISE/ews/sunrise/sendSMS.jsp")
                c.perform()
#                print saver.getvalue()
                if (re.search("Invio annullato: e' stato superato il numero massimo di tentativi di inserimento della password",
                    saver.getvalue()) is None):
                    captchaBroken = True

            if (re.search(
                "&Egrave; possibile inviare gratuitamente fino a 10 SMS al giorno",
                saver.getvalue()) is not None):
                raise SiteCustomError(self.__class__.__name__,
                    u"Sono esauriti gli SMS gratuiti di oggi.")
                           
            if (re.search('Messaggio inviato', saver.getvalue()) == None):
                raise SenderError(self.__class__.__name__)
            
        except pycurl.error, e:
            errno, msg = e
            raise SiteConnectionError(self.__class__.__name__, self.codingManager.iso88591ToUnicode(msg))
