#!/usr/bin/python
# -*- coding: utf-8 -*-
"""Un pannello che visualizza un'icona"""

import wx

class IconPanel(wx.Panel):
    
    image = None
    """Immagine visualizzata o None (nessuna immagine)."""

    def __init__(self, *args, **kwargs):
        wx.Panel.__init__(self, *args, **kwargs)
        self.Bind(wx.EVT_PAINT, self.paintEventHandler)
    
    def setImage(self, image):
        """Cambia l'immagine visualizzata.
        Passando None l'immagine viene rimossa."""
        self.image = image
        self.Refresh(True)
    
    def paintEventHandler(self, event):
        """Disegna l'immagine sulla finestra."""
        dc = wx.PaintDC(self)
        dc.BeginDrawing()
        if self.image is not None:
            dc.DrawBitmap(self.image, 0, 0, True)
        else:
            dc.SetPen(wx.TRANSPARENT_PEN)
            dc.SetBrush(wx.TRANSPARENT_BRUSH)
            width, height = self.GetSize()
            dc.DrawRectangle(0,0,width,height)
        dc.EndDrawing()
        event.Skip()
